diff --git a/bgpd/bgp_route.c b/bgpd/bgp_route.c
index 4441e86fbbf8..b717e349afc1 100644
--- a/bgpd/bgp_route.c
+++ b/bgpd/bgp_route.c
@@ -8545,6 +8545,52 @@ DEFPY(aggregate_addressv4, aggregate_addressv4_cmd,
 				 match_med != NULL, suppress_map);
 }
 
+void bgp_cleanup_aggregate_info(struct bgp *bgp)
+{
+	struct bgp_aggregate *aggregate;
+	afi_t afi;
+	safi_t safi;
+
+	FOREACH_AFI_SAFI (afi, safi) {
+		for (struct bgp_dest *dest =
+			     bgp_table_top(bgp->aggregate[afi][safi]);
+		     dest; dest = bgp_route_next(dest)) {
+			aggregate = bgp_dest_get_bgp_aggregate_info(dest);
+			if (aggregate == NULL)
+				continue;
+
+			/* Unlock aggregate address configuration. */
+			bgp_dest_set_bgp_aggregate_info(dest, NULL);
+
+			if (aggregate->community)
+				community_free(&aggregate->community);
+
+			hash_clean_and_free(&aggregate->community_hash,
+					    bgp_aggr_community_remove);
+
+			if (aggregate->ecommunity)
+				ecommunity_free(&aggregate->ecommunity);
+
+			hash_clean_and_free(&aggregate->ecommunity_hash,
+					    bgp_aggr_ecommunity_remove);
+
+			if (aggregate->lcommunity)
+				lcommunity_free(&aggregate->lcommunity);
+
+			hash_clean_and_free(&aggregate->lcommunity_hash,
+					    bgp_aggr_lcommunity_remove);
+
+			if (aggregate->aspath)
+				aspath_free(aggregate->aspath);
+
+			hash_clean_and_free(&aggregate->aspath_hash,
+					    bgp_aggr_aspath_remove);
+
+			bgp_aggregate_free(aggregate);
+		}
+	}
+}
+
 DEFPY(aggregate_addressv6, aggregate_addressv6_cmd,
       "[no] aggregate-address X:X::X:X/M$prefix [{"
       "as-set$as_set_s"
diff --git a/bgpd/bgp_route.h b/bgpd/bgp_route.h
index b48e8eda1125..6cef96cae652 100644
--- a/bgpd/bgp_route.h
+++ b/bgpd/bgp_route.h
@@ -661,6 +661,7 @@ extern void bgp_process_queue_init(struct bgp *bgp);
 extern void bgp_route_init(void);
 extern void bgp_route_finish(void);
 extern void bgp_cleanup_routes(struct bgp *);
+extern void bgp_cleanup_aggregate_info(struct bgp *bgp);
 extern void bgp_announce_route(struct peer *peer, afi_t afi, safi_t safi,
 			       bool force);
 extern void bgp_stop_announce_route_timer(struct peer_af *paf);
diff --git a/bgpd/bgpd.c b/bgpd/bgpd.c
index 97238bc38b14..2533a63e71af 100644
--- a/bgpd/bgpd.c
+++ b/bgpd/bgpd.c
@@ -3844,6 +3844,7 @@ int bgp_delete(struct bgp *bgp)
 #ifdef ENABLE_BGP_VNC
 	rfapi_delete(bgp);
 #endif
+	bgp_cleanup_aggregate_info(bgp);
 	bgp_cleanup_routes(bgp);
 
 	for (afi = 0; afi < AFI_MAX; ++afi) {
